/*
 * Copyright (c) 2001-2002 Conexant Systems, Inc.
 * 
 * 1.   Permitted use. Redistribution and use in source and binary forms,
 * with or without modification, are permitted under the terms set forth
 * herein.
 * 
 * 2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
 * IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
 * CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.
 * 
 * This software has not been formally tested, and there is no guarantee that
 * it is free of errors including, but not limited to, bugs, defects,
 * interrupted operation, or unexpected results. Any use of this software is
 * at user's own risk.
 * 
 * 3.   No Liability.
 * 
 * (a) Conexant or contributors shall not be responsible for any loss or
 * damage to Company, its customers, or any third parties for any reason
 * whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
 * ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 * WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 * 
 * (b) User agrees to hold Conexant and contributors harmless from any
 * liability, loss, cost, damage or expense, including attorney's fees,
 * as a result of any claims which may be made by any person, including
 * but not limited to User, its agents and employees, its customers, or
 * any third parties that arise out of or result from the manufacture,
 * delivery, actual or alleged ownership, performance, use, operation
 * or possession of the software furnished hereunder, whether such claims
 * are based on negligence, breach of contract, absolute liability or any
 * other legal theory.
 * 
 * 4.   Notices. User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential
 * legends placed upon, contained within or associated with the Software,
 * and shall include all such unaltered copyright, trademark, credits,
 * other proprietary notices or confidential legends on or in every copy of
 * the Software.
 * 
 */

/****************************************************************************************
*                     Version Control Information
*
*	$Header:   P:/d942/octopus/archives/Include/TestDebug.h_v   1.61   11 Dec 2002 10:53:48   beliloi  $
*
*****************************************************************************************/


/****************************************************************************************

File Name:			TestDebug.h

File Description:		

*****************************************************************************************/


#ifndef __TESTDEBUG_H__
#define __TESTDEBUG_H__

#include "osservices.h"


#if defined(_DEBUG) 

    #define USE_TRACE
    #define USE_BREAKPOINT
    #define USE_ASSERT

    #define TRACE_FILE_NAME "ModemLog"

#endif

#if !defined NO_BLAM_SUPPORT && !defined USE_TRACE
    #define USE_TRACE
#endif

#ifdef USE_ASSERT

    #undef ASSERT

    #define ASSERT(x)   {                                                                                           \
                            if(!(x))                                                                                \
                            {																						\
                                RTRACE2(T__ASSERT,0, "Assertion failed, File: %s, Line: %d\n", __FILE__, __LINE__);   \
                                BREAKPOINT("Assert");                                                               \
                            }                                                                                       \
                        }
#else
    
    #undef ASSERT

    #define ASSERT(x)

#endif


#if defined(USE_TRACE) || defined(USE_TRACE_ONLY_ERRORS)

#ifdef USE_TRACE_ONLY_ERRORS
#define ulTraceMask (T__FATAL_ERROR|T__ERROR)
#define ulLogThread 0xdeadbeef
#else
    extern unsigned long ulTraceMask;
    extern unsigned long ulLogThread;
#endif

    #define	T__FATAL_ERROR	0x80000000
    #define T__ERROR		0x40000000
    #define T__ASSERT		0x20000000


#if !defined NO_BLAM_SUPPORT
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/
/*   Background Logging Definitions .... */
/* */
/*		NOTE:	PLEASE, any changes made in TRACE message mask definitions should */
/*				be made also in enum and defaults defined below.  */
/* */
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/

	#include "rpt_io.h"

	/*additional severity mask bits to handle TRACEDM conversion */
	#define TDM__ERROR		0x10000000
	#define TDM__WARNING	0x08000000


	/* */
	/*used to initialize Global Severity filter at port open */
	/* */
	#define BLAM_SEVERITY_DEFAULT (T__FATAL_ERROR|T__ERROR|TDM__ERROR)


	/*arbitrary at the moment */
	#define MAX_NUM_RTRACE_IDS 256

	/*NOTE:  New trace types can be added into this enum anywhere and tracing should */
	/*       work after a recompile.  However, the BLAM application uses this enum */
	/*       to create its database and has trouble parsing comments within it so */
	/*       at the present time PLEASE ADD NO COMMENTS WITHIN THIS ENUM!!! */
	/*       ALSO: Note that any changes to this enum needs corresponding (order */
	/*       dependent changes tot he BLAM_Filters_Default list below.... */
	enum RTRACE_GROUP {	
		T__CALLPROG, 
		T__SESSIONMGR,     
		T__STREAMMGR,
		T__DATASESSION,
		T__MNP,
		T__V42,
		T__V42BIS,
		T__FAXSESSION,
		T__FAXPIM,
		T__ATPARSER,
		T__COMMCTRL,
		T__UTILS,
		T__RTMGR,
		T__CONFIGMGR,
		T__V8BIS,
		T__STATMGR,
		T__PORT,
		T__V8,
		T__PROFILE,
		T__NVMMGR,
		T__TESTSESSION,
		T__DRIVER,
		T__CALLERID,
		T__MOH,
		T__QC,
		T__DIAG,
        T__CW,
        TDM__ENTRY,
		TDM__DM,
		TDM__DPDWNLD,
		TDM__V8BIS,
		TDM__V8,
		TDM__SOFTRI,
		TDM__LMON,
		TDM__HDLC,
		TDM__V14,
		TDM__VSP,
		TDM__HWDS,
		TDM__FAX,
		TDM__WA0,
		TDM__WA1,
		TDM__WA2,
		TDM__FILTER,
		TDM__ASIC,
		TDM__TEST,
		TDM__PULSED,
		TDM__DAA,
		TDM__VOICE,
		TDM__HAL,
		TDM__HALOS,
		TDM__HALDATA,
		TDM__CID,
		TDM__CW,
		TDM__V92,
		TDM__MOH,
		TDM__QC,
        TDM__PIG,
        T__SOFT,
        T__SOFT_AUTOMODE,
        T__SOFT_DATA_EL,
        T__SOFT_DIALER_EL,
        T__SOFT_RINGDET,
        T__SOFT_TONE_EL,
        T__SOFT_SIGNALMGR,
        T__SOFT_B2HW,
        T__SOFT_HW,
        T__SOFT_FILTER_EC,
        T__SOFT_FRED,
        T__SOFT_MODEM_CONFIG,
        T__SOFT_FSK,
        T__SOFT_QAM,
        T__SOFT_V22,
        T__SOFT_V32,
        T__SOFT_HDLC,
        T__SOFT_PROFILER,
        T__SOFT_CAESAR,

		Num_Messages
	};


	/*The FOllowing list is used to initialize trace ON/OFF defaults */
	/*for all of the above enum elements at port open time.  This list may */
	/*be overridden by soft defaults (such as registry....).   */
	/* */
	/*NOTE:		Any change to the above list MUST have a corresponding change to  */
	/*			this list...and THIS list IS order dependent -- it is used */
	/*          to initialize an array of filter criteria values...!!!!! */
	#define BLAM_FILTERS_DEFAULTS {											\
									YES_LOG_MSG_INIT,  /*T__CALLPROG*/		\
									YES_LOG_MSG_INIT,  /*T__SESSIONMGR*/	\
									YES_LOG_MSG_INIT,  /*T__STREAMMGR*/		\
									YES_LOG_MSG_INIT,  /*T__DATASESSION*/	\
									YES_LOG_MSG_INIT,  /*T__MNP*/			\
									DONT_LOG_MSG_INIT, /*T__V42*/			\
									DONT_LOG_MSG_INIT, /*T__V42BIS*/		\
									YES_LOG_MSG_INIT,  /*T__FAXSESSION*/	\
									YES_LOG_MSG_INIT,  /*T__FAXPIM*/		\
									YES_LOG_MSG_INIT,  /*T__ATPARSER*/		\
									YES_LOG_MSG_INIT,  /*T__COMMCTRL*/		\
									YES_LOG_MSG_INIT, /*T__UTILS*/			\
									DONT_LOG_MSG_INIT, /*T__RTMGR*/			\
									DONT_LOG_MSG_INIT, /*T__CONFIGMGR*/		\
									DONT_LOG_MSG_INIT, /*T__V8BIS*/			\
									DONT_LOG_MSG_INIT, /*T__STATMGR*/		\
									DONT_LOG_MSG_INIT, /*T__PORT*/			\
									YES_LOG_MSG_INIT,  /*T__V8*/			\
									YES_LOG_MSG_INIT,  /*T__PROFILE*/		\
									YES_LOG_MSG_INIT,  /*T__NVMMGR*/		\
									YES_LOG_MSG_INIT,  /*T__TESTSESSION*/	\
									DONT_LOG_MSG_INIT, /*T__DRIVER*/		\
									YES_LOG_MSG_INIT,  /*T__CALLERID*/		\
									YES_LOG_MSG_INIT,  /*T__MOH*/			\
									YES_LOG_MSG_INIT,  /*T__QC*/			\
									YES_LOG_MSG_INIT,  /*T__DIAG*/			\
                                    YES_LOG_MSG_INIT,  /*T__CW*/			\
									YES_LOG_MSG_INIT,  /*TDM__ENTRY*/		\
									YES_LOG_MSG_INIT,  /*TDM__DM*/			\
									YES_LOG_MSG_INIT, /*TDM__DPDWNLD*/		\
									DONT_LOG_MSG_INIT, /*TDM__V8BIS*/		\
									YES_LOG_MSG_INIT,  /*TDM__V8*/			\
									YES_LOG_MSG_INIT,  /*TDM__SOFTRI*/		\
									YES_LOG_MSG_INIT,  /*TDM__LMON*/		\
									DONT_LOG_MSG_INIT, /*TDM__HDLC*/		\
									YES_LOG_MSG_INIT,  /*TDM__V14*/			\
									YES_LOG_MSG_INIT, /*TDM__VSP*/			\
									YES_LOG_MSG_INIT,  /*TDM__HWDS*/		\
									YES_LOG_MSG_INIT,  /*TDM__FAX*/			\
									YES_LOG_MSG_INIT,  /*TDM__WA0*/			\
									YES_LOG_MSG_INIT,  /*TDM__WA1*/			\
									YES_LOG_MSG_INIT,  /*TDM__WA2*/			\
									YES_LOG_MSG_INIT,  /*TDM__FILTER*/		\
									YES_LOG_MSG_INIT,  /*TDM__ASIC*/		\
									YES_LOG_MSG_INIT,  /*TDM__TEST*/		\
									YES_LOG_MSG_INIT,  /*TDM__PULSED*/		\
									YES_LOG_MSG_INIT,  /*TDM__DAA*/			\
									YES_LOG_MSG_INIT,  /*TDM__VOICE*/		\
									YES_LOG_MSG_INIT,  /*TDM__HAL*/			\
									DONT_LOG_MSG_INIT, /*TDM__HALOS*/		\
									DONT_LOG_MSG_INIT, /*TDM__HALDATA*/		\
									YES_LOG_MSG_INIT,  /*TDM__CID*/			\
									YES_LOG_MSG_INIT,  /*TDM__CW*/			\
									YES_LOG_MSG_INIT,  /*TDM__V92*/			\
									YES_LOG_MSG_INIT,  /*TDM__MOH*/			\
									YES_LOG_MSG_INIT,  /*TDM__QC*/			\
                                    DONT_LOG_MSG_INIT, /*TDM__PIG*/           \
                                    YES_LOG_MSG_INIT,  /*T__SOFT*/			\
                                    YES_LOG_MSG_INIT,  /*T__SOFT_AUTOMODE*/ \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_DATA_EL*/  \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_DIALER_EL*/\
                                    YES_LOG_MSG_INIT,  /*T__SOFT_RINGDET*/  \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_TONE_EL*/  \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_SIGNALMGR*/\
                                    YES_LOG_MSG_INIT,  /*T__SOFT_B2HW*/     \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_HW*/       \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_FILTER_EC*/\
                                    YES_LOG_MSG_INIT,  /*T__SOFT_FRED*/     \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_MODEM_CONFIG*/\
                                    YES_LOG_MSG_INIT,  /*T__SOFT_FSK*/      \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_QAM*/      \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_V22*/      \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_V32*/      \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_HDLC*/      \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_PROFILER*/  \
                                    YES_LOG_MSG_INIT,  /*T__SOFT_CAESAR*/  \
								}


	/*SINCE THE RTRACE APPLICATION IS DESIGNED TO HANDLE MULTIPLE CLIENTS WE MUST ASSIGN AN ID NUMBER TO OUT CLIENT */
	#define DW_CLIENT_ID ((UINT32)0)
	
	/*already defined in rpt_io.h */
/*	#define	LINE_NUM_MASK				((DWORD) 0x00003FFF)	DH	BITS 0-13 */

    #define RTRACE0(TypeAndSeverity, LoggingThread, str)  RPT_Write(			\
					DW_CLIENT_ID,												\
					(TypeAndSeverity | (LoggingThread << 16)),					\
					((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14),			\
					0);


	#define RTRACE1(TypeAndSeverity, LoggingThread, str, arg1)  RPT_Write(				\
					DW_CLIENT_ID,														\
					(TypeAndSeverity | (LoggingThread << 16)),							\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (1 <<29)),		\
					arg1);

	
	#define RTRACE2(TypeAndSeverity, LoggingThread, str, arg1, arg2)  RPT_Write(	\
					DW_CLIENT_ID,													\
					(TypeAndSeverity | (LoggingThread << 16)),						\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (2 <<29)),	\
					arg1, arg2);


	#define RTRACE3(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3)  RPT_Write(	\
					DW_CLIENT_ID,													\
					(TypeAndSeverity | (LoggingThread << 16)),						\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (3 <<29)),	\
					arg1, arg2, arg3)


	#define RTRACE4(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4)  RPT_Write(	\
					DW_CLIENT_ID,																\
					(TypeAndSeverity | (LoggingThread << 16)),									\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (4 <<29)),				\
					arg1, arg2, arg3, arg4)


	#define RTRACE5(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5)  RPT_Write(		\
					DW_CLIENT_ID,																		\
					(TypeAndSeverity | (LoggingThread << 16)),											\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (5 <<29)),						\
					arg1, arg2, arg3, arg4, arg5)						


	#define RTRACE6(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6)  RPT_Write(	\
					DW_CLIENT_ID,																			\
					(TypeAndSeverity | (LoggingThread << 16)),												\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (6 <<29)),							\
					arg1, arg2, arg3, arg4, arg5, arg6)


	#define RTRACE7(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6, arg7)  RPT_Write(		\
					DW_CLIENT_ID,																					\
					(TypeAndSeverity | (LoggingThread << 16)),														\
					(((__LINE__) & LINE_NUM_MASK) | (FILEIDNUM << 14) | (7 <<29)),									\
					arg1, arg2, arg3, arg4, arg5, arg6, arg7)

#else     /* !defined NO_BLAM_SUPPORT */

	#define	T__CALLERID		0x00000001
    #define T__CALLPROG		0x00000002
    #define T__SESSIONMGR	0x00000004
    #define T__STREAMMGR	0x00000008
    #define T__DATASESSION	0x00000010
    #define T__MNP			0x00000020
    #define T__V42			0x00000040
    #define T__V42BIS		0x00000080
    #define T__FAXSESSION	0x00000100
    #define T__FAXPIM		0x00000200
    #define T__ATPARSER		0x00000400
    #define T__COMMCTRL		0x00000800
    #define T__UTILS		0x00001000
    #define T__RTMGR		0x00002000
    #define T__CONFIGMGR    0x00004000
	#define	T__MOH			0x00008000
    #define T__V8BIS        0x00010000
    #define T__STATMGR      0x00020000
	#define T__QC			0x00040000

    #define T__TIMING		0x00100000
    #define T__PORT         0x00200000
    #define T__V8           0x00400000
	#define	T__DIAG			0x00800000
    #define T__DRIVER	    0x01000000
    #define T__PROFILE		0x02000000
    #define T__NVMMGR		0x04000000
    #define T__TESTSESSION	0x08000000	  /*PQ */
	#define T__VOICESESSION 0x10000000	  /*#$YS$ */
    #define T__SOFT             0x00000001
    #define T__SOFT_AUTOMODE    0x00000001
    #define T__SOFT_DATA_EL     0x00000001
    #define T__SOFT_DIALER_EL   0x00000001
    #define T__SOFT_RINGDET     0x00000001
    #define T__SOFT_TONE_EL     0x00000001
    #define T__SOFT_SIGNALMGR   0x00000001
    #define T__SOFT_B2HW        0x00000001
    #define T__SOFT_HW          0x00000001
    #define T__SOFT_FILTER_EC   0x00000001
    #define T__SOFT_FRED        0x00000001
    #define T__SOFT_MODEM_CONFIG 0x00000001
    #define T__SOFT_FSK         0x00000001
    #define T__SOFT_QAM         0x00000001
    #define T__SOFT_V22         0x00000001
    #define T__SOFT_V32         0x00000001
    #define T__SOFT_HDLC        0x00000001
    #define T__SOFT_PROFILER    0x00000001
    #define T__SOFT_CAESAR      0x00000001

/*
#if defined TARGET_HSF_PCI_MACOSX
    #define TDM__ERROR						0x00000001
    #define TDM__WARNING					0x00000002
    #define TDM__ENTRY						0x00000004
    #define TDM__DM							0x00000008
    #define TDM__DPDWNLD					0x00000010
    #define TDM__V8BIS						0x00000020
    #define TDM__V8							0x00000040
    #define TDM__SOFTRI						0x00000080
    #define TDM__LMON						0x00000100
    #define TDM__HDLC						0x00000200
    #define TDM__V14						0x00000400
    #define TDM__VSP						0x00000800
    #define TDM__HWDS						0x00001000
    #define TDM__FAX						0x00002000
    #define TDM__WA0						0x00004000
    #define TDM__WA1						0x00008000
    #define TDM__WA2						0x00010000
    #define TDM__FILTER						0x00020000
    #define TDM__ASIC						0x00040000
    #define TDM__TEST						0x00080000
    #define TDM__PULSED						0x00100000
    #define TDM__DAA						0x00200000
    #define TDM__VOICE						0x00400000
    #define TDM__HAL						0x00800000
    #define TDM__HALOS						0x01000000
    #define TDM__HALDATA					0x02000000
    #define	TDM__CID						0x04000000
    #define	TDM__CW							0x08000000
    #define	TDM__V92						0x10000000
    #define	TDM__MOH						0x20000000
    #define TDM__QC							0x40000000
    #define TDM__PIG						0x80000000
#endif
*/
    #define T__CW           T__CALLERID
	
	/*This lets us use either ulTraceMask or dwDmTraceMask assuming the  */
	/*os_x.h file is always included before the Testdebug.h file... */
	#ifndef NOBLAMTRACEMASK
		#define NOBLAMTRACEMASK  ulTraceMask
	#endif
	#ifndef NOBLAMLOGGINGTHREAD
        #define NOBLAMLOGGINGTHREAD ulLogThread
	#endif

	/*These are here to let code converted to BLAM trace via WinICE */
	#define RTRACE0(TypeAndSeverity, LoggingThread, str) {										\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
                                {																\
                                    UINT32 dwTime = OsGetSystemTime();							\
                                    OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);    \
                                    OsDebugPrintf (str);										\
                                }																\
                            }


	#define RTRACE1(TypeAndSeverity, LoggingThread, str, arg1) {								\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
                                {																\
                                    UINT32 dwTime = OsGetSystemTime();							\
                                    OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);    \
                                    OsDebugPrintf (str, arg1);									\
                                }																\
                            }

	#define NOTIME_RTRACE1(TypeAndSeverity, LoggingThread, str, arg1) {								\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
                                {																\
                                    OsDebugPrintf (str, arg1);									\
                                }																\
                            }


	#define RTRACE2(TypeAndSeverity, LoggingThread, str, arg1, arg2) {						\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
							{																\
                                UINT32 dwTime = OsGetSystemTime();							\
                                OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);    \
                                OsDebugPrintf (str, arg1, arg2);							\
                            }																\
                        }


	#define RTRACE3(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3) {	        \
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
						{												                \
                            UINT32 dwTime = OsGetSystemTime();					        \
                            OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);    \
                            OsDebugPrintf (str, arg1, arg2, arg3);                      \
						}															    \
                    }


	#define RTRACE4(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4) {	    \
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
					{												                    \
                        UINT32 dwTime = OsGetSystemTime();					            \
                        OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);        \
                        OsDebugPrintf (str, arg1, arg2, arg3, arg4);                    \
                    }																	\
                }


	#define RTRACE5(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5) {	\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
					{																		\
                        UINT32 dwTime = OsGetSystemTime();									\
                        OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);			\
                        OsDebugPrintf (str, arg1, arg2, arg3, arg4, arg5);                  \
                    }																		\
                }


	#define RTRACE6(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6) {	\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
					{																			\
                        UINT32 dwTime = OsGetSystemTime();										\
                        OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);				\
                        OsDebugPrintf (str, arg1, arg2, arg3, arg4, arg5, arg6);                \
                    }																			\
                }



	#define RTRACE7(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {	\
                    if (((TypeAndSeverity) & NOBLAMTRACEMASK) ||	(LoggingThread == NOBLAMLOGGINGTHREAD)) \
						{																				\
                            UINT32 dwTime = OsGetSystemTime();											\
                            OsDebugPrintf ("%07d.%03d: HCF: ", dwTime/1000, dwTime%1000);					\
                            OsDebugPrintf (str, arg1, arg2, arg3, arg4, arg5, arg6, arg7);              \
                        }																				\
                    }

#endif   /* !defined NO_BLAM_SUPPORT */



    #define TRACE(mask,printf)  {                                           \
                                    if ((mask) & ulTraceMask)               \
                                    {                                       \
                                        UINT32 dwTime = OsGetSystemTime();  \
                                        OsDebugPrintf ("%07d.%03d: ", dwTime/1000, dwTime%1000); \
                                        OsDebugPrintf printf;               \
                                    }                                       \
                                }
    #define DUMP(mask,printf)  {                                           \
                                    if ((mask) & ulTraceMask)               \
                                    {                                       \
                                        OsDebugPrintf printf;               \
                                    }                                       \
                                }

	#define DUMPDATA(mask, data, len) /*{                                           \
	void DumpData(PUINT8 data, UINT32 len);					\
                                    if ((mask) & ulTraceMask)               \
                                    {                                       \
                                        DumpData(data, len);               \
                                    }                                       \
                                }
*/	

#else

#define NO_BLAM_SUPPORT

    #define TRACE(mask, printf)
    #define DUMP(mask,printf)
	#define DUMPDATA(mask, data, len)
	
    #define RTRACE0(TypeAndSeverity, LoggingThread, str)
	#define RTRACE1(TypeAndSeverity, LoggingThread, str, arg1)
	#define RTRACE2(TypeAndSeverity, LoggingThread, str, arg1, arg2)
	#define RTRACE3(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3)
	#define RTRACE4(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4)
	#define RTRACE5(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5)
	#define RTRACE6(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6)
	#define RTRACE7(TypeAndSeverity, LoggingThread, str, arg1, arg2, arg3, arg4, arg5, arg6, arg7)

#endif


#ifdef USE_BREAKPOINT

    #define BREAKPOINT(msg)     { OsDebugBreakpoint(msg);   }

#else

    #define BREAKPOINT(msg)

#endif






#endif  /* #ifndef __DEBUG_H__ */
